import type { ExtractTypeOfValidatorValue, Validator } from './validateAtoms';
import { AtomWithValidation } from './validateAtoms';
export type Options<Vkeys extends symbol | string | number, Vvals> = {
    validate: Validator<Vkeys, Vvals>;
};
export type ActionableNext = {
    action: 'SET_VALUE' | 'SET_FOCUSED' | 'SET_TOUCHED';
    key: string;
    value: any;
};
export type FormControls<Keys extends string, Vals> = {
    isValid: boolean;
    fieldErrors: {
        [k: string]: any;
    };
    touched: Record<Keys, boolean>;
    focused: Record<Keys, boolean>;
    setValue(key: Keys, value: Vals): void;
    setTouched(key: Keys, val: boolean): void;
    setFocused(key: Keys, val: boolean): void;
    handleOnChange(key: Keys): (val: any) => void;
    handleOnFocus(key: Keys): () => unknown;
    handleOnBlur(key: Keys): () => void;
    values: Record<Keys, ExtractTypeOfValidatorValue<Vals>>;
    error: unknown;
    isValidating: boolean | undefined;
};
export declare function atomWithFormControls<AtomGroup extends Record<string, AtomWithValidation<any>>, Keys extends Extract<keyof AtomGroup, string>, Vals extends AtomGroup[Keys]>(labeledAtoms: AtomGroup, options?: Options<Keys, Vals>): import("jotai/vanilla").Atom<FormControls<Keys, Vals>>;
