import type { SetStateAction, WritableAtom } from 'jotai/vanilla';
import type { CommonState } from './atomWithValidate';
export type ExtractTypeOfValidatorValue<Type> = Type extends AtomWithValidation<infer X> ? X : never;
export type Validator<Keys extends symbol | string | number, Vals> = (values: Record<Keys, ExtractTypeOfValidatorValue<Vals>>) => void | Promise<void>;
export type ValidatorState = {
    isValid: undefined | boolean;
    error: null | Error | unknown;
    isValidating: undefined | boolean;
};
export type AtomWithValidation<Value> = WritableAtom<CommonState<Value>, [
    SetStateAction<Value>
], void>;
type State<Values extends Record<string, unknown>> = {
    values: Values;
} & ValidatorState;
export declare const validateAtoms: <AtomGroup extends Record<string, AtomWithValidation<any>>, Keys extends keyof AtomGroup, Vals extends AtomGroup[Keys]>(labeledAtoms: AtomGroup, validator: Validator<Keys, Vals>) => import("jotai/vanilla").Atom<State<Record<Keys, ExtractTypeOfValidatorValue<Vals>>>>;
export {};
